C     Copyright (C) 2008-2014 D. V. Wiebe
C
C     CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     This file is part of the GetData project.
C
C     GetData is free software; you can redistribute it and/or modify it under
C     the terms of the GNU Lesser General Public License as published by the
C     Free Software Foundation; either version 2.1 of the License, or (at your
C     option) any later version.
C    
C     GetData is distributed in the hope that it will be useful, but WITHOUT
C     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
C     FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
C     License for more details.
C    
C     You should have received a copy of the GNU Lesser General Public License
C     along with GetData; if not, write to the Free Software Foundation, Inc.,
C     51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
C

C     Fortran 77 parameters for GetData.  This file defines handy
C     constants useful to Fortran programs.

      
C     Error codes
C     Corresponding to GD_E_OK
      INTEGER GD_EOK
      PARAMETER (GD_EOK=0)
C     Corresponding to GD_E_FORMAT
      INTEGER GD_EFO
      PARAMETER (GD_EFO=-1)
C     Corresponding to GD_E_CREAT
      INTEGER GD_ECR
      PARAMETER (GD_ECR=-2)
C     Corresponding to GD_E_BAD_CODE
      INTEGER GD_EBC
      PARAMETER (GD_EBC=-3)
C     Corresponding to GD_E_BAD_TYPE
      INTEGER GD_EBT
      PARAMETER (GD_EBT=-4)
C     Corresponding to GD_E_IO
      INTEGER GD_EIO
      PARAMETER (GD_EIO=-5)
C     Corresponding to GD_E_INTERNAL_ERROR
      INTEGER GD_EIE
      PARAMETER (GD_EIE=-6)
C     Corresponding to GD_E_ALLOC
      INTEGER GD_EAL
      PARAMETER (GD_EAL=-7)
C     Corresponding to GD_E_RANGE
      INTEGER GD_ERA
      PARAMETER (GD_ERA=-8)
C     Corresponding to GD_E_LUT
      INTEGER GD_ELT
      PARAMETER (GD_ELT=-9)
C     Corresponding to GD_E_RECURSE_LEVEL
      INTEGER GD_ERL
      PARAMETER (GD_ERL=-10)
C     Corresponding to GD_E_BAD_DIRFILE
      INTEGER GD_EBD
      PARAMETER (GD_EBD=-11)
C     Corresponding to GD_E_BAD_FIELD_TYPE
      INTEGER GD_EBF
      PARAMETER (GD_EBF=-12)
C     Corresponding to GD_E_ACCMODE
      INTEGER GD_EAC
      PARAMETER (GD_EAC=-13)
C     Corresponding to GD_E_UNSUPPORTED
      INTEGER GD_UNS
      PARAMETER (GD_UNS=-14)
C     Corresponding to GD_E_UNKNOWN_ENCODING
      INTEGER GD_EUE
      PARAMETER (GD_EUE=-15)
C     Corresponding to GD_E_BAD_ENTRY
      INTEGER GD_EBE
      PARAMETER (GD_EBE=-16)
C     Corresponding to GD_E_DUPLICATE
      INTEGER GD_EDU
      PARAMETER (GD_EDU=-17)
C     Corresponding to GD_E_DIMENSION
      INTEGER GD_EDM
      PARAMETER (GD_EDM=-18)
C     Corresponding to GD_E_BAD_INDEX
      INTEGER GD_EBI
      PARAMETER (GD_EBI=-19)
C     Corresponding to GD_E_BAD_SCALAR
      INTEGER GD_EBS
      PARAMETER (GD_EBS=-20)
C     Corresponding to GD_E_BAD_REFERENCE
      INTEGER GD_EBR
      PARAMETER (GD_EBR=-21)
C     Corresponding to GD_E_PROTECTED
      INTEGER GD_EPT
      PARAMETER (GD_EPT=-22)
C     Corresponding to GD_E_DELETE
      INTEGER GD_EDL
      PARAMETER (GD_EDL=-23)
C     Corresponding to GD_E_ARGUMENT
      INTEGER GD_EAR
      PARAMETER (GD_EAR=-24)
C     Corresponding to GD_E_CALLBACK
      INTEGER GD_ECB
      PARAMETER (GD_ECB=-25)
C     Corresponding to GD_E_EXISTS
      INTEGER GD_EEX
      PARAMETER (GD_EEX=-26)
C     Corresponding to GD_E_UNCLEAN_DB
      INTEGER GD_UCL
      PARAMETER (GD_UCL=-27)
C     Corresponding to GD_E_DOMAIN
      INTEGER GD_EDO
      PARAMETER (GD_EDO=-28)
C     Corresponding to GD_E_BAD_REPR
      INTEGER GD_ERP
      PARAMETER (GD_ERP=-3)
C     Corresponding to GD_E_BOUNDS
      INTEGER GD_EBO
      PARAMETER (GD_EBO=-29)
C     Corresponding to GD_E_LINE_TOO_LONG
      INTEGER GD_ETL
      PARAMETER (GD_ETL=-30)

C Deprecated error codes
C     Corresponding to GD_E_BAD_ENDIANNESS
      INTEGER GD_EEN
      PARAMETER (GD_EEN=-24)
C     Corresponding to GD_E_BAD_PROTECTION
      INTEGER GD_EBP
      PARAMETER (GD_EBP=-24)
C     Corresponding to GD_E_BAD_VERSION
      INTEGER GD_EVR
      PARAMETER (GD_EVR=-24)
C     Corresponding to GD_E_OPEN_LINFILE
      INTEGER GD_EOL
      PARAMETER (GD_EOL=-9)
C     Corresponding to GD_E_FLUSH
      INTEGER GD_EFL
      PARAMETER (GD_EFL=-5)
C     Corresponding to GD_E_OPEN
      INTEGER GD_EOP
      PARAMETER (GD_EOP=-5)
C     Corresponding to GD_E_OPEN_FRAGMENT
      INTEGER GD_EOF
      PARAMETER (GD_EOF=-5)
C     Corresponding to GD_E_OPEN_INCLUDE
      INTEGER GD_EOI
      PARAMETER (GD_EOI=-5)
C     Corresponding to GD_E_RAW_IO
      INTEGER GD_ERW
      PARAMETER (GD_ERW=-5)
C     Corresponding to GD_E_TRUNC
      INTEGER GD_ETR
      PARAMETER (GD_ETR=-5)

C Open flags
C     Corresponding to GD_RDONLY
      INTEGER GD_RO
      PARAMETER (GD_RO=0)
C     Corresponding to GD_RDWR
      INTEGER GD_RW
      PARAMETER (GD_RW=1)
C     Corresponding to GD_FORCE_ENDIAN
      INTEGER GD_FE
      PARAMETER (GD_FE=2)
C     Corresponding to GD_BIG_ENDIAN
      INTEGER GD_BE
      PARAMETER (GD_BE=4)
C     Corresponding to GD_LITTLE_ENDIAN
      INTEGER GD_LE
      PARAMETER (GD_LE=8)
C     Corresponding to GD_CREAT
      INTEGER GD_CR
      PARAMETER (GD_CR=16)
C     Corresponding to GD_EXCL
      INTEGER GD_EX
      PARAMETER (GD_EX=32)
C     Corresponding to GD_TRUNC
      INTEGER GD_TR
      PARAMETER (GD_TR=64)
C     Corresponding to GD_PEDANTIC
      INTEGER GD_PE
      PARAMETER (GD_PE=128)
C     Corresponding to GD_FORCE_ENCODING
      INTEGER GD_FC
      PARAMETER (GD_FC=256)
C     Corresponding to GD_VERBOSE
      INTEGER GD_VB
      PARAMETER (GD_VB=512)
C     Corresponding to GD_IGNORE_DUPS
      INTEGER GD_ID
      PARAMETER (GD_ID=1024)
C     Corresponding to GD_IGNORE_REFS
      INTEGER GD_IR
      PARAMETER (GD_IR=2048)
C     Corresponding to GD_PRETTY_PRINT
      INTEGER GD_PP
      PARAMETER (GD_PP=4096)
C     Corresponding to GD_ARM_ENDIAN
      INTEGER GD_AE
      PARAMETER (GD_AE=8192)
C     Corresponding to GD_NOT_ARM_ENDIAN
      INTEGER GD_NA
      PARAMETER (GD_NA=0)
C     Corresponding to GD_PERMISSIVE
      INTEGER GD_PM
      PARAMETER (GD_PM=16384)
C     Corresponding to GD_TRUNCSUB
      INTEGER GD_TS
      PARAMETER (GD_TS=32768)
C     Corresponding to GD_AUTO_ENCODED
      INTEGER GDE_AU
      PARAMETER (GDE_AU=0)
C     Corresponding to GD_BZIP2_ENCODED
      INTEGER GDE_BZ
      PARAMETER (GDE_BZ=83886080)
C     Corresponding to GD_FLAC_ENCODED
      INTEGER GDE_FL
      PARAMETER (GDE_FL=167772160)
C     Corresponding to GD_GZIP_ENCODED
      INTEGER GDE_GZ
      PARAMETER (GDE_GZ=67108864)
C     Corresponding to GD_LZMA_ENCODED
      INTEGER GDE_LZ
      PARAMETER (GDE_LZ=100663296)
C     Corresponding to GD_SIE_ENCODED
      INTEGER GDE_SI
      PARAMETER (GDE_SI=117440512)
C     Corresponding to GD_SLIM_ENCODED
      INTEGER GDE_SL
      PARAMETER (GDE_SL=50331648)
C     Corresponding to GD_TEXT_ENCODED
      INTEGER GDE_TX
      PARAMETER (GDE_TX=33554432)
C     Corresponding to GD_UNENCODED
      INTEGER GDE_UN
      PARAMETER (GDE_UN=16777216)
C     Corresponding to GD_ZZSLIM_ENCODED
      INTEGER GDE_ZS
      PARAMETER (GDE_ZS=150994944)
C     Corresponding to GD_ZZIP_ENCODED
      INTEGER GDE_ZZ
      PARAMETER (GDE_ZZ=134217728)

C Entry types
C     Corresponding to GD_NO_ENTRY
      INTEGER GD_NOE
      PARAMETER (GD_NOE=0)
C     Corresponding to GD_RAW_ENTRY
      INTEGER GD_RWE
      PARAMETER (GD_RWE=1)
C     Corresponding to GD_LINCOM_ENTRY
      INTEGER GD_LCE
      PARAMETER (GD_LCE=2)
C     Corresponding to GD_LINTERP_ENTRY
      INTEGER GD_LTE
      PARAMETER (GD_LTE=3)
C     Corresponding to GD_BIT_ENTRY
      INTEGER GD_BTE
      PARAMETER (GD_BTE=4)
C     Corresponding to GD_MULTIPLY_ENTRY
      INTEGER GD_MTE
      PARAMETER (GD_MTE=5)
C     Corresponding to GD_PHASE_ENTRY
      INTEGER GD_PHE
      PARAMETER (GD_PHE=6)
C     Corresponding to GD_INDEX_ENTRY
      INTEGER GD_IXE
      PARAMETER (GD_IXE=7)
C     Corresponding to GD_POLYNOM_ENTRY
      INTEGER GD_PNE
      PARAMETER (GD_PNE=8)
C     Corresponding to GD_SBIT_ENTRY
      INTEGER GD_SBE
      PARAMETER (GD_SBE=9)
C     Corresponding to GD_DIVIDE_ENTRY
      INTEGER GD_DVE
      PARAMETER (GD_DVE=10)
C     Corresponding to GD_RECIP_ENTRY
      INTEGER GD_RCE
      PARAMETER (GD_RCE=11)
C     Corresponding to GD_WINDOW_ENTRY
      INTEGER GD_WDE
      PARAMETER (GD_WDE=12)
C     Corresponding to GD_MPLEX_ENTRY
      INTEGER GD_MXE
      PARAMETER (GD_MXE=13)
C     Corresponding to GD_INDIR_ENTRY
      INTEGER GD_IDE
      PARAMETER (GD_IDE=14)
C     Corresponding to GD_SINDIR_ENTRY
      INTEGER GD_SDE
      PARAMETER (GD_SDE=15)
C     Corresponding to GD_CONST_ENTRY
      INTEGER GD_COE
      PARAMETER (GD_COE=16)
C     Corresponding to GD_CARRAY_ENTRY
      INTEGER GD_CAE
      PARAMETER (GD_CAE=18)
C     Corresponding to GD_SARRAY_ENTRY
      INTEGER GD_SAE
      PARAMETER (GD_SAE=19)
C     Corresponding to GD_STRING_ENTRY
      INTEGER GD_STE
      PARAMETER (GD_STE=17)

C Data types -- the unsigned types won't work when passed as
C               a return type; they are defined because they
C               may be returned by GDGERW or GDNTYP
C     Corresponding to GD_NULL
      INTEGER GD_NUL
      PARAMETER (GD_NUL=0)
C     Corresponding to GD_UINT8
      INTEGER GD_U8
      PARAMETER (GD_U8=1)
C     Corresponding to GD_INT8
      INTEGER GD_I8
      PARAMETER (GD_I8=33)
C     Corresponding to GD_UINT16
      INTEGER GD_U16
      PARAMETER (GD_U16=2)
C     Corresponding to GD_INT16
      INTEGER GD_I16
      PARAMETER (GD_I16=34)
C     Corresponding to GD_UINT32
      INTEGER GD_U32
      PARAMETER (GD_U32=4)
C     Corresponding to GD_INT32
      INTEGER GD_I32
      PARAMETER (GD_I32=36)
C     Corresponding to GD_UINT64
      INTEGER GD_U64
      PARAMETER (GD_U64=8)
C     Corresponding to GD_INT64
      INTEGER GD_I64
      PARAMETER (GD_I64=40)
C     Corresponding to GD_FLOAT32
      INTEGER GD_F32
      PARAMETER (GD_F32=132)
C     Corresponding to GD_FLOAT64
      INTEGER GD_F64
      PARAMETER (GD_F64=136)
C     Corresponding to GD_COMPLEX64
      INTEGER GD_C64
      PARAMETER (GD_C64=264)
C     Corresponding to GD_COMPLEX128
      INTEGER GDC128
      PARAMETER (GDC128=272)
C     Corresponding to GD_STRING
      INTEGER GD_STR
      PARAMETER (GD_STR=520)

C Delete and Rename flags
C     Corresponding to GD_DEL_META
      INTEGER GDD_MT
      PARAMETER (GDD_MT=1)
C     Corresponding to GD_DEL_DATA
      INTEGER GDD_DT
      PARAMETER (GDD_DT=2)
C     Corresponding to GD_DEL_DEREF
      INTEGER GDD_DR
      PARAMETER (GDD_DR=4)
C     Corresponding to GD_DEL_FORCE
      INTEGER GDD_FO
      PARAMETER (GDD_FO=8)
C     Corresponding to GD_REN_DATA
      INTEGER GDR_DT
      PARAMETER (GDR_DT=1)
C     Corresponding to GD_REN_UPDB
      INTEGER GDR_UP
      PARAMETER (GDR_UP=2)
C     Corresponding to GD_REN_DANGLE
      INTEGER GDR_DL
      PARAMETER (GDR_DL=4)
C     Corresponding to GD_REN_FORCE
      INTEGER GDR_FO
      PARAMETER (GDR_FO=8)

C Protection levels
C     Corresponding to GD_PROTECT_NONE
      INTEGER GDPR_N
      PARAMETER (GDPR_N=0)
C     Corresponding to GD_PROTECT_FORMAT
      INTEGER GDPR_F
      PARAMETER (GDPR_F=1)
C     Corresponding to GD_PROTECT_DATA
      INTEGER GDPR_D
      PARAMETER (GDPR_D=2)
C     Corresponding to GD_PROTECT_ALL
      INTEGER GDPR_A
      PARAMETER (GDPR_A=3)

C Callback actions
C     Corresponding to GD_SYNTAX_ABORT
      INTEGER GDSX_A
      PARAMETER (GDSX_A=0)
C     Corresponding to GD_SYNTAX_RESCAN
      INTEGER GDSX_S
      PARAMETER (GDSX_S=1)
C     Corresponding to GD_SYNTAX_IGNORE
      INTEGER GDSX_I
      PARAMETER (GDSX_I=2)
C     Corresponding to GD_SYNTAX_CONTINUE
      INTEGER GDSX_C
      PARAMETER (GDSX_C=3)

C Syntax suberrors
C     Corresponding to GD_E_FORMAT_BAD_SPF
      INTEGER GDF_SF
      PARAMETER (GDF_SF=1)
C     Corresponding to GD_E_FORMAT_N_FIELDS
      INTEGER GDF_NF
      PARAMETER (GDF_NF=2)
C     Corresponding to GD_E_FORMAT_N_TOK
      INTEGER GDF_NT
      PARAMETER (GDF_NT=3)
C     Corresponding to GD_E_FORMAT_NUMBITS
      INTEGER GDF_NB
      PARAMETER (GDF_NB=4)
C     Corresponding to GD_E_FORMAT_BITNUM
      INTEGER GDF_BN
      PARAMETER (GDF_BN=5)
C     Corresponding to GD_E_FORMAT_BITSIZE
      INTEGER GDF_SZ
      PARAMETER (GDF_SZ=6)
C     Corresponding to GD_E_FORMAT_CHARACTER
      INTEGER GDF_CH
      PARAMETER (GDF_CH=7)
C     Corresponding to GD_E_FORMAT_BAD_LINE
      INTEGER GDF_LI
      PARAMETER (GDF_LI=8)
C     Corresponding to GD_E_FORMAT_RES_NAME
      INTEGER GDF_RN
      PARAMETER (GDF_RN=9)
C     Corresponding to GD_E_FORMAT_ENDIAN
      INTEGER GDF_EN
      PARAMETER (GDF_EN=10)
C     Corresponding to GD_E_FORMAT_BAD_TYPE
      INTEGER GDF_TY
      PARAMETER (GDF_TY=11)
C     Corresponding to GD_E_FORMAT_BAD_NAME
      INTEGER GDF_NA
      PARAMETER (GDF_NA=12)
C     Corresponding to GD_E_FORMAT_UNTERM
      INTEGER GDF_UM
      PARAMETER (GDF_UM=13)
C     Corresponding to GD_E_FORMAT_METARAW
      INTEGER GDF_MR
      PARAMETER (GDF_MR=14)
C     Corresponding to GD_E_FORMAT_NO_PARENT
      INTEGER GDF_PA
      PARAMETER (GDF_PA=15)
C     Corresponding to GD_E_FORMAT_DUPLICATE
      INTEGER GDF_DU
      PARAMETER (GDF_DU=16)
C     Corresponding to GD_E_FORMAT_LOCATION
      INTEGER GDF_LO
      PARAMETER (GDF_LO=17)
C     Corresponding to GD_E_FORMAT_PROTECT
      INTEGER GDF_PR
      PARAMETER (GDF_PR=18)
C     Corresponding to GD_E_FORMAT_LITERAL
      INTEGER GDF_LT
      PARAMETER (GDF_LT=19)
C     Corresponding to GD_E_FORMAT_WINDOP
      INTEGER GDF_WO
      PARAMETER (GDF_WO=20)
C     Corresponding to GD_E_FORMAT_META_META
      INTEGER GDF_MM
      PARAMETER (GDF_MM=21)
C     Corresponding to GD_E_FORMAT_ALIAS
      INTEGER GDF_AL
      PARAMETER (GDF_AL=22)
C     Corresponding to GD_E_FORMAT_MPLEXVAL
      INTEGER GDF_MV
      PARAMETER (GDF_MV=23)

C Special version codes
C     Corresponding to GD_VERSION_CURRENT
      INTEGER GDSV_C
      PARAMETER (GDSV_C=-1)
C     Corresponding to GD_VERSION_LATEST
      INTEGER GDSV_L
      PARAMETER (GDSV_L=-2)
C     Corresponding to GD_VERSION_EARLIEST
      INTEGER GDSV_E
      PARAMETER (GDSV_E=-3)

C Seek flags
C     Corresponding to GD_SEEK_SET
      INTEGER GDSK_S
      PARAMETER (GDSK_S=0)
C     Corresponding to GD_SEEK_CUR
      INTEGER GDSK_C
      PARAMETER (GDSK_C=1)
C     Corresponding to GD_SEEK_END
      INTEGER GDSK_E
      PARAMETER (GDSK_E=2)
C     Corresponding to GD_SEEK_WRITE
      INTEGER GDSK_W
      PARAMETER (GDSK_W=4)

C Window operations
C     Corresponding to GD_WINDOP_UNK
      INTEGER GDW_UN
      PARAMETER (GDW_UN=0)
C     Corresponding to GD_WINDOP_EQ
      INTEGER GDW_EQ
      PARAMETER (GDW_EQ=1)
C     Corresponding to GD_WINDOP_GE
      INTEGER GDW_GE
      PARAMETER (GDW_GE=2)
C     Corresponding to GD_WINDOP_GT
      INTEGER GDW_GT
      PARAMETER (GDW_GT=3)
C     Corresponding to GD_WINDOP_LE
      INTEGER GDW_LE
      PARAMETER (GDW_LE=4)
C     Corresponding to GD_WINDOP_LT
      INTEGER GDW_LT
      PARAMETER (GDW_LT=5)
C     Corresponding to GD_WINDOP_NE
      INTEGER GDW_NE
      PARAMETER (GDW_NE=6)
C     Corresponding to GD_WINDOP_SET
      INTEGER GDW_ST
      PARAMETER (GDW_ST=7)
C     Corresponding to GD_WINDOP_CLR
      INTEGER GDW_CL
      PARAMETER (GDW_CL=8)

C Desync flags
C     Corresponding to GD_DESYNC_PATHCHECK
      INTEGER GDDS_P
      PARAMETER (GDDS_P=1)
C     Corresponding to GD_DESYNC_REOPEN
      INTEGER GDDS_O
      PARAMETER (GDDS_O=2)

C Entry List codes and flags
C     Corresponding to GD_ALL_ENTRIES
      INTEGER GDEN_X
      PARAMETER (GDEN_X=0)
C     Corresponding to GD_VECTOR_ENTRIES
      INTEGER GDEN_V
      PARAMETER (GDEN_V=33)
C     Corresponding to GD_SCALAR_ENTRIES
      INTEGER GDEN_S
      PARAMETER (GDEN_S=34)
C     Corresponding to GD_ALIAS_ENTRIES
      INTEGER GDEN_A
      PARAMETER (GDEN_A=-1)
C     Corresponding to GD_ENTRIES_HIDDEN
      INTEGER GDEN_H
      PARAMETER (GDEN_H=1)
C     Corresponding to GD_ENTRIES_NOALIAS
      INTEGER GDEN_N
      PARAMETER (GDEN_N=2)
C     Corresponding to GD_REGEX_PCRE
      INTEGER GDRX_P
      PARAMETER (GDRX_P=4)
C     Corresponding to GD_REGEX_EXTENDED
      INTEGER GDRX_X
      PARAMETER (GDRX_X=8)
C     Corresponding to GD_REGEX_ICASE
      INTEGER GDRX_I
      PARAMETER (GDRX_I=16)
C     Corresponding to GD_REGEX_CASELESS
      INTEGER GDRX_C
      PARAMETER (GDRX_C=16)
C     Corresponding to GD_REGEX_JAVASCRIPT
      INTEGER GDRX_J
      PARAMETER (GDRX_J=32)
C     Corresponding to GD_REGEX_UNICODE
      INTEGER GDRX_U
      PARAMETER (GDRX_U=64)

C Entry object flags
C     Corresponding to GD_EN_CALC
      INTEGER GDE_CA
      PARAMETER (GDE_CA=2)
C     Corresponding to GD_EN_HIDDEN
      INTEGER GDE_HI
      PARAMETER (GDE_HI=4)
C     Corresponding to GD_EN_COMPSCAL
      INTEGER GDE_CS
      PARAMETER (GDE_CS=1)

C Miscellaneous parameters
C     Corresponding to GD_ALL_FRAGMENTS
      INTEGER GD_ALL
      PARAMETER (GD_ALL=-1)
C     Corresponding to GD_DEFAULT_LOOKBACK
      INTEGER GDLB_D
      PARAMETER (GDLB_D=10)
C     Corresponding to GD_DIRFILE_STANDARDS_VERSION
      INTEGER GD_DSV
      PARAMETER (GD_DSV=10)
C     Corresponding to GD_HERE
      INTEGER GD_HER
      PARAMETER (GD_HER=-1)
C     Corresponding to GD_LOOKBACK_ALL
      INTEGER GDLB_A
      PARAMETER (GDLB_A=-1)
C     Corresponding to GD_MAX_LINE_LENGTH
      INTEGER GD_MLL
      PARAMETER (GD_MLL=4096)


C     The length of the opaque packed data string returned by GDGSTP
      INTEGER GDPKSZ
      PARAMETER (GDPKSZ=8)

C Externals
C     Corresponding to gd_alter_affixes(3)
      EXTERNAL GDAAFX
C     Corresponding to gd_add_alias(3)
      EXTERNAL GDADAL
C     Corresponding to gd_add_bit(3)
      EXTERNAL GDADBT
C     Corresponding to gd_add_carray(3)
      EXTERNAL GDADCA
C     Corresponding to gd_add_clincom(3)
      EXTERNAL GDADCL
C     Corresponding to gd_add_const(3)
      EXTERNAL GDADCO
C     Corresponding to gd_add_cpolynom(3)
      EXTERNAL GDADCP
C     Corresponding to gd_add_crecip(3)
      EXTERNAL GDADCR
C     Corresponding to gd_add_divide(3)
      EXTERNAL GDADDV
C     Corresponding to gd_add_indir(3)
      EXTERNAL GDADID
C     Corresponding to gd_add_lincom(3)
      EXTERNAL GDADLC
C     Corresponding to gd_add_linterp(3)
      EXTERNAL GDADLT
C     Corresponding to gd_add_multiply(3)
      EXTERNAL GDADMT
C     Corresponding to gd_add_mplex(3)
      EXTERNAL GDADMX
C     Corresponding to gd_add_phase(3)
      EXTERNAL GDADPH
C     Corresponding to gd_add_polynom(3)
      EXTERNAL GDADPN
C     Corresponding to gd_add_recip(3)
      EXTERNAL GDADRC
C     Corresponding to gd_add_raw(3)
      EXTERNAL GDADRW
C     Corresponding to gd_add_sarray(3)
      EXTERNAL GDADSA
C     Corresponding to gd_add_sbit(3)
      EXTERNAL GDADSB
C     Corresponding to gd_add_sindir(3)
      EXTERNAL GDADSD
C     Corresponding to gd_add_spec(3)
      EXTERNAL GDADSP
C     Corresponding to gd_add_string(3)
      EXTERNAL GDADST
C     Corresponding to gd_add_window(3)
      EXTERNAL GDADWD
C     Correpsonding to gd_alter_encoding(3)
      EXTERNAL GDAENC
C     Correpsonding to gd_alter_endianness(3)
      EXTERNAL GDAEND
C     Correpsonding to gd_alter_frameoffset(3)
      EXTERNAL GDAFOF
C     Correpsonding to gd_alter_bit(3)
      EXTERNAL GDALBT
C     Correpsonding to gd_alter_carray(3)
      EXTERNAL GDALCA
C     Correpsonding to gd_alter_clincom(3)
      EXTERNAL GDALCL
C     Correpsonding to gd_alter_const(3)
      EXTERNAL GDALCO
C     Correpsonding to gd_alter_cpolynom(3)
      EXTERNAL GDALCP
C     Correpsonding to gd_alter_crecip(3)
      EXTERNAL GDALCR
C     Correpsonding to gd_alter_divide(3)
      EXTERNAL GDALDV
C     Correpsonding to gd_alter_indir(3)
      EXTERNAL GDALID
C     Correpsonding to gd_alter_lincom(3)
      EXTERNAL GDALLC
C     Correpsonding to gd_alter_linterp(3)
      EXTERNAL GDALLT
C     Correpsonding to gd_alter_multiply(3)
      EXTERNAL GDALMT
C     Corresponding to gd_alter_mplex(3)
      EXTERNAL GDALMX
C     Correpsonding to gd_alter_phase(3)
      EXTERNAL GDALPH
C     Correpsonding to gd_alter_polynom(3)
      EXTERNAL GDALPN
C     Correpsonding to gd_alter_recip(3)
      EXTERNAL GDALRC
C     Correpsonding to gd_alter_raw(3)
      EXTERNAL GDALRW
C     Correpsonding to gd_alter_sarray(3)
      EXTERNAL GDALSA
C     Correpsonding to gd_alter_sbit(3)
      EXTERNAL GDALSB
C     Correpsonding to gd_alter_sindir(3)
      EXTERNAL GDALSD
C     Correpsonding to gd_alter_spec(3)
      EXTERNAL GDALSP
C     Correpsonding to gd_aliases(3)
      EXTERNAL GDALSS
C     Returns the maximum alias length
      EXTERNAL GDALSX
C     Corresponding to gd_alter_window(3)
      EXTERNAL GDALWD
C     Corresponding to gd_alter_protection(3)
      EXTERNAL GDAPRT
C     Corresponding to gd_array_len(3)
      EXTERNAL GDARLN
C     Alter a scalar parameter
      EXTERNAL GDASCA
C     Corresponding to gd_add(3) for BIT fields
      EXTERNAL GDASBT
C     Corresponding to gd_add(3) for complex-valued LINCOM fields
      EXTERNAL GDASCL
C     Corresponding to gd_add(3) for complex-valued POLYNOM fields
      EXTERNAL GDASCP
C     Corresponding to gd_add(3) for complex-valued RECIP fields
      EXTERNAL GDASCR
C     Corresponding to gd_add(3) for LINCOM fields
      EXTERNAL GDASLC
C     Corresponding to gd_add(3) for MPLEX fields
      EXTERNAL GDASMX
C     Corresponding to gd_add(3) for PHASE fields
      EXTERNAL GDASPH
C     Corresponding to gd_add(3) for POLYNOM fields
      EXTERNAL GDASPN
C     Corresponding to gd_add(3) for RECIP fields
      EXTERNAL GDASRC
C     Corresponding to gd_add(3) for RAW fields
      EXTERNAL GDASRW
C     Corresponding to gd_add(3) for SBIT fields
      EXTERNAL GDASSB
C     Corresponding to gd_add(3) for WINDOW fields
      EXTERNAL GDASWD
C     Corresponding to gd_alias_target(3)
      EXTERNAL GDATRG
C     The following function is deprecated! use GDARLN instead
      EXTERNAL GDCALN
C     Corresponding to gd_parser_callback(3)
      EXTERNAL GDCLBK
C     Corresponding to gd_close(3)
      EXTERNAL GDCLOS
C     Corresponding to gd_constants(3) (sort of)
      EXTERNAL GDCONS
C     Corresponding to gd_copen(3)
      EXTERNAL GDCOPN
C     Correpsonding to gd_delete_alias(3)
      EXTERNAL GDDELA
C     Correpsonding to gd_delete(3)
      EXTERNAL GDDELE
C     Corresponding to gd_discard(3)
      EXTERNAL GDDSCD
C     Frees the packed data returned by GDGSTP
      EXTERNAL GDDSTP
C     Corresponding to gd_desync(3)
      EXTERNAL GDDSYN
C     Corresponding to gd_error_count(3)
      EXTERNAL GDECNT
C     Corresponding to gd_encoding_support(3)
      EXTERNAL GDENCS
C     Returns entry flags
      EXTERNAL GDENFL
C     Corresponding to gd_entry_list(3) (sort of)
      EXTERNAL GDENTN
C     Returns the maximum entry name length
      EXTERNAL GDENTX
C     Corresponding to gd_entry_type(3)
      EXTERNAL GDENTY
C     Corresponding to gd_error(3)
      EXTERNAL GDEROR
C     Corresponding to gd_error_string(3)
      EXTERNAL GDESTR
C     Corresponding to gd_field_list_by_type(3) (sort of)
      EXTERNAL GDFDNT
C     Returns the maximum field name length
      EXTERNAL GDFDNX
C     Corresponding to gd_flags(3)
      EXTERNAL GDFLAG
C     Corresponding to gd_field_list(3) (sort of)
      EXTERNAL GDFLDN
C     Corresponding to gd_flush(3)
      EXTERNAL GDFLSH
C     Corresponding to gd_framenum_subset(3)
      EXTERNAL GDFNSS
C     Corresponding to gd_framenum(3)
      EXTERNAL GDFNUM
C     Corresponding to gd_fragment_affixes(3)
      EXTERNAL GDFRAF
C     Corresponding to gd_fragment_namespace(3)
      EXTERNAL GDFRNS
C     Corresponding to gd_fragment_index(3)
      EXTERNAL GDFRGI
C     Corresponding to gd_fragmentname(3)
      EXTERNAL GDFRGN
C     Corresponding to gd_bof(3)
      EXTERNAL GDGBOF
C     Corresponding to gd_get_carray_slice(3)
      EXTERNAL GDGCAS
C     Corresponding to gd_entry(3) for BIT fields
      EXTERNAL GDGEBT
C     Corresponding to gd_entry(3) for CARRAY fields
      EXTERNAL GDGECA
C     Corresponding to gd_entry(3) for complex-valued LINCOM fields
      EXTERNAL GDGECL
C     Corresponding to gd_entry(3) for CONST fields
      EXTERNAL GDGECO
C     Corresponding to gd_entry(3) for complex-valued POLYNOM fields
      EXTERNAL GDGECP
C     Corresponding to gd_entry(3) for complex-valued RECIP fields
      EXTERNAL GDGECR
C     Corresponding to gd_entry(3) for INDIR fields
      EXTERNAL GDGEID
C     Corresponding to gd_entry(3) for LINCOM fields
      EXTERNAL GDGELC
C     Corresponding to gd_entry(3) for LINTERP fields
      EXTERNAL GDGELT
C     Corresponding to gd_entry(3) for MULTIPLY fields
      EXTERNAL GDGEMT
C     Corresponding to gd_encoding(3)
      EXTERNAL GDGENC
C     Corresponding to gd_endianness(3)
      EXTERNAL GDGEND
C     Corresponding to gd_eof(3)
      EXTERNAL GDGEOF
C     Corresponding to gd_entry(3) for PHASE fields
      EXTERNAL GDGEPH
C     Corresponding to gd_entry(3) for POLYNOM fields
      EXTERNAL GDGEPN
C     Corresponding to gd_entry(3) for RECIP fields
      EXTERNAL GDGERC
C     Corresponding to gd_entry(3) for RAW fields
      EXTERNAL GDGERW
C     Corresponding to gd_entry(3) for SARRAY fields
      EXTERNAL GDGESA
C     Corresponding to gd_entry(3) for SBIT fields
      EXTERNAL GDGESB
C     Corresponding to gd_entry(3) for SINDIR fields
      EXTERNAL GDGESD
C     Corresponding to gd_getdata(3)
      EXTERNAL GDGETD
C     Corresponding to gd_entry(3) for WINDOW fields
      EXTERNAL GDGEWD
C     Correpsonding to gd_frameoffset(3)
      EXTERNAL GDGFOF
C     Corresponding to gd_protection(3)
      EXTERNAL GDGPRT
C     Retrieve a scalar parameter
      EXTERNAL GDGSCA
C     Corresponding to gd_spf(3)
      EXTERNAL GDGSPF
C     Gets one sample of a SINDIR via gd_getstrdata(3)
      EXTERNAL GDGSTD
C     Gets a packed array of SINDIR data via gd_getstrdata(3)
C     see also GDXSTP and GDDSTP and the GDPKSZ parameter above
      EXTERNAL GDGSTP
C     Corresponding to gd_get_carray(3)
      EXTERNAL GDGTCA
C     Corresponding to gd_get_constant(3)
      EXTERNAL GDGTCO
C     Gets a single SARRAY element via gd_get_sarray_slice(3)
      EXTERNAL GDGTSA
C     Corresponding to gd_get_string(3)
      EXTERNAL GDGTST
C     Corresponding to gd_hide(3)
      EXTERNAL GDHIDE
C     Corresponding to gd_hidden(3)
      EXTERNAL GDHIDN
C     Corresponding to gd_include_affixes(3)
      EXTERNAL GDINCA
C     Corresponding to gd_include(3)
      EXTERNAL GDINCL
C     Corresponding to gd_include_ns(3)
      EXTERNAL GDINCN
C     Corresponding to gd_invalid_dirfile(3)
      EXTERNAL GDINVD
C     Corresponding to gd_alter_entry(3) for BIT fields
      EXTERNAL GDLSBT
C     Corresponding to gd_alter_entry(3) for complex-valued LINCOM fields
      EXTERNAL GDLSCL
C     Corresponding to gd_alter_entry(3) for complex-valued POLYNOM fields
      EXTERNAL GDLSCP
C     Corresponding to gd_alter_entry(3) for complex-valued RECIP fields
      EXTERNAL GDLSCR
C     Corresponding to gd_alter_entry(3) for LINCOM fields
      EXTERNAL GDLSLC
C     Corresponding to gd_alter_entry(3) for MPLEX fields
      EXTERNAL GDLSMX
C     Corresponding to gd_alter_entry(3) for PHASE fields
      EXTERNAL GDLSPH
C     Corresponding to gd_alter_entry(3) for POLYNOM fields
      EXTERNAL GDLSPN
C     Corresponding to gd_alter_entry(3) for RECIP fields
      EXTERNAL GDLSRC
C     Corresponding to gd_alter_entry(3) for RAW fields
      EXTERNAL GDLSRW
C     Corresponding to gd_alter_entry(3) for SBIT fields
      EXTERNAL GDLSSB
C     Corresponding to gd_alter_entry(3) for WINDOW fields
      EXTERNAL GDLSWD
C     Corresponding to gd_linterp_tablename(3)
      EXTERNAL GDLTTN
C     Corresponding to gd_match_entries(3)
      EXTERNAL GDMATN
C     Returns the maximum entry name length
      EXTERNAL GDMATX
C     Corresponding to gd_mconstants(3) (sort of)
      EXTERNAL GDMCOS
C     Corresponding to gd_madd_alias(3)
      EXTERNAL GDMDAL
C     Corresponding to gd_madd_bit(3)
      EXTERNAL GDMDBT
C     Corresponding to gd_madd_carray(3)
      EXTERNAL GDMDCA
C     Corresponding to gd_madd_clincom(3)
      EXTERNAL GDMDCL
C     Corresponding to gd_madd_const(3)
      EXTERNAL GDMDCO
C     Corresponding to gd_madd_cpolynom(3)
      EXTERNAL GDMDCP
C     Corresponding to gd_madd_crecip(3)
      EXTERNAL GDMDCR
C     Corresponding to gd_madd_divide(3)
      EXTERNAL GDMDDV
C     Corresponding to gd_madd_indir(3)
      EXTERNAL GDMDID
C     Corresponding to gd_madd_lincom(3)
      EXTERNAL GDMDLC
C     Corresponding to gd_madd_linterp(3)
      EXTERNAL GDMDLT
C     Corresponding to gd_madd_multiply(3)
      EXTERNAL GDMDMT
C     Corresponding to gd_madd_mplex(3)
      EXTERNAL GDMDMX
C     Corresponding to gd_madd_phase(3)
      EXTERNAL GDMDPH
C     Corresponding to gd_madd_polynom(3)
      EXTERNAL GDMDPN
C     Corresponding to gd_madd_recip(3)
      EXTERNAL GDMDRC
C     Corresponding to gd_madd_sarray(3)
      EXTERNAL GDMDSA
C     Corresponding to gd_madd_sbit(3)
      EXTERNAL GDMDSB
C     Corresponding to gd_madd_sindir(3)
      EXTERNAL GDMDSD
C     Corresponding to gd_madd_spec(3)
      EXTERNAL GDMDSP
C     Corresponding to gd_madd_string(3)
      EXTERNAL GDMDST
C     Corresponding to gd_madd_window(3)
      EXTERNAL GDMDWD
C     Corresponding to gd_mfield_list(3) (sort of)
      EXTERNAL GDMFDN
C     Corresponding to gd_mfield_list_by_type(3) (sort of)
      EXTERNAL GDMFDT
C     Corresponding to gd_metaflush(3)
      EXTERNAL GDMFLS
C     Returns the maximum field name length for a meta field list
      EXTERNAL GDMFNX
C     Correpsonding to gd_malter_spec(3)
      EXTERNAL GDMLSP
C     Correpsonding to gd_move(3)
      EXTERNAL GDMOVE
C     Returns the maximum meta sarray value length
      EXTERNAL GDMSAX
C     Corresponding to gd_mstrings(3) (sort of)
      EXTERNAL GDMSTS
C     Returns the maximum length of the longest string metafield for a
C     field
      EXTERNAL GDMSTX
C     Corresponding to gd_mvector_list(3) (sort of)
      EXTERNAL GDMVEN
C     Corresponding to gd_mplex_lookback(3)
      EXTERNAL GDMXLB
C     Corresponding to gd_naliases(3)
      EXTERNAL GDNALS
C     Corresponding to gd_dirfilename(3)
      EXTERNAL GDNAME
C     Corresponding to gd_nentries(3)
      EXTERNAL GDNENT
C     Corresponding to gd_nfields_by_type(3)
      EXTERNAL GDNFDT
C     Corresponding to gd_nfields(3)
      EXTERNAL GDNFLD
C     Corresponding to gd_nfragments(3)
      EXTERNAL GDNFRG
C     Corresponding to gd_nframes(3)
      EXTERNAL GDNFRM
C     Corresponding to gd_match_entries(3)
      EXTERNAL GDNMAT
C     Corresponding to gd_nmfields(3)
      EXTERNAL GDNMFD
C     Corresponding to gd_nmfields_by_type(3)
      EXTERNAL GDNMFT
C     Corresponding to gd_nmvectors(3)
      EXTERNAL GDNMVE
C     Deregister a callback function (ie. gd_parser_callback(..., NULL))
      EXTERNAL GDNOCB
C     Corresponding to gd_native_type(3)
      EXTERNAL GDNTYP
C     Corresponding to gd_nvectors(3)
      EXTERNAL GDNVEC
C     Corresponding to gd_open(3)
      EXTERNAL GDOPEN
C     Corresponding to gd_put_carray_slice(3)
      EXTERNAL GDPCAS
C     Corresponding to gd_parent_fragment(3)
      EXTERNAL GDPFRG
C     Corresponding to gd_put_carray(3)
      EXTERNAL GDPTCA
C     Corresponding to gd_put_constant(3)
      EXTERNAL GDPTCO
C     Puts a single SARRAY element via gd_put_sarray_slice(3)
      EXTERNAL GDPTSA
C     Corresponding to gd_put_string(3)
      EXTERNAL GDPTST
C     Corresponding to gd_putdata(3)
      EXTERNAL GDPUTD
C     Corresponding to gd_raw_close(3)
      EXTERNAL GDRCLO
C     Corresponding to gd_reference(3)
      EXTERNAL GDREFE
C     Correpsonding to gd_rename(3)
      EXTERNAL GDRENM
C     Corresponding to gd_rewrite_fragment(3)
      EXTERNAL GDRFRG
C     Corresponding to gd_raw_filename(3)
      EXTERNAL GDRWFN
C     Returns the maximum sarray value length
      EXTERNAL GDSARX
C     Corresponding to gd_seek(3)
      EXTERNAL GDSEEK
C     Corresponding to gd_dirfile_standards(3)
      EXTERNAL GDSTDV
C     Corresponding to gd_strings(3) (sort of)
      EXTERNAL GDSTRS
C     Returns the length of the longest string field
      EXTERNAL GDSTRX
C     Corresponding to gd_sync(3)
      EXTERNAL GDSYNC
C     Corresponding to gd_tell(3)
      EXTERNAL GDTELL
C     Corresponding to gd_strtok(3)
      EXTERNAL GDTOKE
C     Corresponding to gd_unhide(3)
      EXTERNAL GDUHID
C     Corresponding to gd_uninclude(3)
      EXTERNAL GDUINC
C     Corresponding to gd_verbose_prefix(3)
      EXTERNAL GDVBPX
C     Corresponding to gd_vector_list(3) (sort of)
      EXTERNAL GDVECN
C     Corresponding to gd_validate(3)
      EXTERNAL GDVLDT
C     Extracts one sample from the data returned by GDGSTP
      EXTERNAL GDXSTP
